package com.szpg.task;

import com.szpg.db.dao.impl.PgAcuRdcmdDaoImpl;
import com.szpg.db.data.PgAcuRdcmd;
import com.szpg.plc.message.AppCommand;
import com.szpg.plc.message.command.read.ReadDSStatusCommand;
import com.szpg.plc.protocol.DTProtocolInterface;
import com.szpg.plc.protocol.ProtocolFactory;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;

public class ReadDSStatusTask implements Runnable {

	private ACUClient client;
	private AppCommand appCommand;

	public ReadDSStatusTask(ACUClient client, AppCommand command) {
		this.client = client;
		this.appCommand = command;
	}

	@Override
	public void run() {
		DTProtocolInterface finspi = ProtocolFactory.getDefaultDTProtocol();
		byte[] content = finspi.messageToBytes(appCommand);
		
		// 发送读取对射报警状态内存命令
		ACUClientUtil.getInstance().sendACUCommand(client, content);
		
		ReadDSStatusCommand dsAlmCmd = (ReadDSStatusCommand) appCommand;

		// 发送完成之后将命令保存在数据库中
		PgAcuRdcmd cmd = new PgAcuRdcmd();
		cmd.setCmd_type(dsAlmCmd.getCommandType());
		cmd.setDest(dsAlmCmd.getDestinationId());
		cmd.setMem_area_cd(ByteUtil.binToHexString(new byte[] { dsAlmCmd.getMemoryArea() }));
		cmd.setStart_mem_word(dsAlmCmd.getStartAddress().substring(0, 4));
		cmd.setStart_mem_bit(dsAlmCmd.getStartAddress().substring(4));
		cmd.setCount_word(dsAlmCmd.getCountWord());
		cmd.setCount_bit(dsAlmCmd.getCountBit());
		cmd.setCount_sensor(dsAlmCmd.getCountSensor());
		
		new PgAcuRdcmdDaoImpl().addCmdRecord(cmd);
	}

}
